[<prev] [next>] [<thread-prev] [thread-next>] [day] [month] [year] [list]
Message-Id: <1466536893-23355-5-git-send-email-mcgrof@kernel.org>
Date: Tue, 21 Jun 2016 12:21:29 -0700
From: "Luis R. Rodriguez" <mcgrof@...nel.org>
To: Julia.Lawall@...6.fr, Gilles.Muller@...6.fr, nicolas.palix@...g.fr,
mmarek@...e.com
Cc: linux-kernel@...r.kernel.org, akpm@...ux-foundation.org,
gregkh@...uxfoundation.org, markivx@...eaurora.org,
stephen.boyd@...aro.org, zohar@...ux.vnet.ibm.com,
broonie@...nel.org, ming.lei@...onical.com, tiwai@...e.de,
johannes@...solutions.net, chunkeey@...glemail.com,
hauke@...ke-m.de, jwboyer@...oraproject.org,
dmitry.torokhov@...il.com, dwmw2@...radead.org, jslaby@...e.com,
torvalds@...ux-foundation.org, deepa.kernel@...il.com,
cocci@...teme.lip6.fr, "Luis R. Rodriguez" <mcgrof@...nel.org>
Subject: [PATCH v3 4/8] coccicheck: replace --very-quiet with --quit when debugging
When debugging (using --profile or --show-trying) you want to
avoid supressing output, use --quiet instead. While at it, extend
documentation for SPFLAGS use.
For instance one can use:
$ export COCCI=scripts/coccinelle/misc/irqf_oneshot.cocci
$ make coccicheck DEBUG_FILE="poo.err" MODE=report SPFLAGS="--profile --show-trying" M=./drivers/mfd/arizona-irq.c
v3: rebased, resolve conflicts
v2: use egrep instead of the *"=--option"* check, this doesn't work for
disjunctions.
Signed-off-by: Luis R. Rodriguez <mcgrof@...nel.org>
---
scripts/coccicheck | 23 +++++++++++++++++++++++
1 file changed, 23 insertions(+)
diff --git a/scripts/coccicheck b/scripts/coccicheck
index a77f0f246405..998d764636e0 100755
--- a/scripts/coccicheck
+++ b/scripts/coccicheck
@@ -32,6 +32,29 @@ fi
FLAGS="--very-quiet"
+# You can use SPFLAGS to append extra arguments to coccicheck or override any
+# heuristics done in this file as Coccinelle accepts the last options when
+# options conflict.
+#
+# A good example for use of SPFLAGS is if you want to debug your cocci script,
+# you can for instance use the following:
+#
+# $ export COCCI=scripts/coccinelle/misc/irqf_oneshot.cocci
+# $ make coccicheck MODE=report DEBUG_FILE="all.err" SPFLAGS="--profile --show-trying" M=./drivers/mfd/arizona-irq.c
+#
+# "--show-trying" should show you what rule is being processed as it goes to
+# stdout, you do not need a debug file for that. The profile output will be
+# be sent to stdout, if you provide a DEBUG_FILE the profiling data can be
+# inspected there.
+#
+# --profile will not output if --very-quiet is used, so avoid it.
+echo $SPFLAGS | egrep -e "--profile|--show-trying" 2>&1 > /dev/null
+if [ $? -eq 0 ]; then
+ FLAGS="--quiet"
+else
+ FLAGS="--very-quiet"
+fi
+
# spatch only allows include directories with the syntax "-I include"
# while gcc also allows "-Iinclude" and "-include include"
COCCIINCLUDE=${LINUXINCLUDE//-I/-I }
--
2.8.2
Powered by blists - more mailing lists